DEFINE VAR err-count AS INT INIT 0.

DISPLAY "ADD SEQUENCE ""my-seq-1"" INIT 10 INC 3 CYCLE no MIN-VAL 10" SKIP.
/* make sure we start from the beginning */
CURRENT-VALUE(my-seq-1) = 10.
DISPLAY "S: Reset to [" + STRING(CURRENT-VALUE(my-seq-1)) + "]" FORMAT "x(16)".

DISPLAY NEXT-VALUE(my-seq-1). /* the value it's 13 */
DISPLAY NEXT-VALUE(my-seq-1). /* the value it's 16 */
DISPLAY SKIP.
IF CURRENT-VALUE(my-seq-1) <> 16 THEN 
    DO:
        DISPLAY "next-value failed on seq 1" SKIP.
        err-count = err-count + 1.
    END.

/* make sure we start from the beginning */
DYNAMIC-CURRENT-VALUE("my-seq-1", "p2j_test") = 10.
DISPLAY "D: Reset to [" + STRING(DYNAMIC-CURRENT-VALUE("my-seq-1", "p2j_test")) + "]" FORMAT "x(16)".

DISPLAY DYNAMIC-NEXT-VALUE("my-seq-1", "p2j_test"). /* the value it's 13 */
DISPLAY DYNAMIC-NEXT-VALUE("my-seq-1", "p2j_test"). /* the value it's 16 */
DISPLAY SKIP.
IF DYNAMIC-CURRENT-VALUE("my-seq-1", "p2j_test") <> 16 THEN 
    DO:
        DISPLAY "next-value failed on seq 1" SKIP.
        err-count = err-count + 1.
    END.
/* we cannot test unterminated sequences */
DISPLAY SKIP(1).

DISPLAY "ADD SEQUENCE ""my-seq-2"" INIT 0 INC -1 CYCLE no MIN-VAL -3 MAX-VAL 0" SKIP.
/* make sure we start from the beginning */
CURRENT-VALUE(my-seq-2) = 0.
DISPLAY "S: Reset to [" + STRING(CURRENT-VALUE(my-seq-2)) + "]" FORMAT "x(16)".

DISPLAY NEXT-VALUE(my-seq-2). /* the value it's -1 */
DISPLAY NEXT-VALUE(my-seq-2). /* the value it's -2 */
DISPLAY NEXT-VALUE(my-seq-2). /* the value it's -3 */
DISPLAY NEXT-VALUE(my-seq-2). /* the value it's ? - no cycle */
DISPLAY CURRENT-VALUE(my-seq-2). /* the value it's ? - in theory */
DISPLAY SKIP.
IF CURRENT-VALUE(my-seq-2) <> ? THEN 
DO:
    DISPLAY "next-value failed on seq 2" SKIP.
    err-count = err-count + 1.
END.

/* make sure we start from the beginning */
DYNAMIC-CURRENT-VALUE("my-seq-2", "p2j_test") = 0.
DISPLAY "D: Reset to [" + STRING(DYNAMIC-CURRENT-VALUE("my-seq-2", "p2j_test")) + "]" FORMAT "x(16)".

DISPLAY DYNAMIC-NEXT-VALUE("my-seq-2", "p2j_test"). /* the value it's -1 */
DISPLAY DYNAMIC-NEXT-VALUE("my-seq-2", "p2j_test"). /* the value it's -2 */
DISPLAY DYNAMIC-NEXT-VALUE("my-seq-2", "p2j_test"). /* the value it's -3 */
DISPLAY DYNAMIC-NEXT-VALUE("my-seq-2", "p2j_test"). /* the value it's ? - no cycle */
DISPLAY DYNAMIC-CURRENT-VALUE("my-seq-2", "p2j_test"). /* the value it's ? - in theory */
DISPLAY SKIP.
IF DYNAMIC-CURRENT-VALUE("my-seq-2", "p2j_test") <> ? THEN 
DO:
    DISPLAY "next-value failed on seq 2" SKIP.
    err-count = err-count + 1.
END.
DISPLAY SKIP(1).


DISPLAY "ADD SEQUENCE ""my-seq-3"" INIT 0 INC 10 CYCLE yes MIN-VAL 0 MAX-VAL 10" SKIP.
/* make sure we start from the beginning */
CURRENT-VALUE(my-seq-3) = 0.
DISPLAY "S: Reset to [" + STRING(CURRENT-VALUE(my-seq-3)) + "]" FORMAT "x(16)".

DISPLAY NEXT-VALUE(my-seq-3). /* the value it's 10 */
DISPLAY NEXT-VALUE(my-seq-3). /* the value it's 0 - warp cycle sequence */
DISPLAY SKIP.
IF CURRENT-VALUE(my-seq-3) <> 0 THEN
DO:
    DISPLAY "next-value failed on seq 3" SKIP.
    err-count = err-count + 1.
END.

/* make sure we start from the beginning */
DYNAMIC-CURRENT-VALUE("my-seq-3", "p2j_test") = 0.
DISPLAY "D: Reset to [" + STRING(DYNAMIC-CURRENT-VALUE("my-seq-3", "p2j_test")) + "]" FORMAT "x(16)".

DISPLAY DYNAMIC-NEXT-VALUE("my-seq-3", "p2j_test"). /* the value it's 10 */
DISPLAY DYNAMIC-NEXT-VALUE("my-seq-3", "p2j_test"). /* the value it's 0 - warp cycle sequence */
DISPLAY SKIP.
IF DYNAMIC-CURRENT-VALUE("my-seq-3", "p2j_test") <> 0 THEN
DO:
    DISPLAY "next-value failed on seq 3" SKIP.
    err-count = err-count + 1.
END.
DISPLAY SKIP(1).

DISPLAY IF err-count = 0 THEN  "all ok." ELSE STRING(err-count) + " errors found.".


